package main

/*
	this parses the command line arguements

	this enables command line options from other packages like 'gui' and 'log'
*/

type args struct {
	// Repo string `arg:"positional"               help:"go import path"`
	// Increment    bool   `arg:"--increment"              help:"auto increment"`
	// Release      bool   `arg:"--release"                help:"do a release an exit"`
	DryRun       bool   `arg:"--dry-run,env:DRYRUN"     help:"don't actually do the release"`
	Fix          bool   `arg:"--fix"                    help:"run fixGoMod() on startup"`
	Reason       string `arg:"--reason"                 help:"tag message"`
	DumpVersions bool   `arg:"--dump-versions"          help:"dump the versions file for go.wit.com"`
	Port         int    `arg:"--port"     default:"9419"         help:"do fun stuff with curl"`
}

func (a args) Description() string {
	return `
Example usage:
	guireleaser go.wit.com/apps/go-clone --increment --release --dry-run --reason "blerg"

This will pull down the go sources and
the repositories in the go.sum file using git clone`
}

func (args) Version() string {
	return "guireleaser " + VERSION
}
