package main

import (
	"go.wit.com/gui"
	"go.wit.com/lib/debugger"
	"go.wit.com/lib/gui/logsettings"
	"go.wit.com/log"
)

func globalDisplayOptions(box *gui.Node) {
	vbox := box.NewVerticalBox("DISPLAYVBOX")

	group1 := vbox.NewGroup("Global Display Options")

	hidegrid := group1.NewGrid("hidecfg", 0, 0)

	hidegrid.NewButton("Show Repository Window", func() {
		if me.repos.Hidden() {
			me.repos.Show()
		} else {
			me.repos.Hide()
		}
		log.Info("showing reposwin")
	})
	hidegrid.NextRow()

	group1 = vbox.NewGroup("prep for release")
	grid := group1.RawGrid()

	grid.NewButton("make prepare-release", func() {
		makePrepareRelease()
	})
	grid.NextRow()

	grid.NewButton("logging Window", func() {
		logsettings.LogWindow()
	})
	grid.NextRow()

	grid.NewButton("Debugger Window", func() {
		debugger.DebugWindow()
	})
}
