package main

import (
	"fmt"

	"go.wit.com/lib/gui/repolist"
	"go.wit.com/log"
)

func PrintReport(readonly string, onlydirty string, perfect string) {
	var count int

	log.Info(repolist.ReportHeader())

	loop := me.repos.View.ReposSortByName()
	for loop.Scan() {
		repo := loop.Repo()

		count += 1
		header := repo.StandardHeader()
		if onlydirty == "true" {
			if repo.CheckDirty() {
				log.Info(header + "")
			}
			continue
		}

		if me.forge.Config.IsReadOnly(repo.GoPath()) {
			if readonly == "true" {
				log.Info(header + "readonly")
			}
			continue
		}
		if repo.State() == "PERFECT" {
			if perfect == "false" {
				continue
			}
		}
		if repo.State() != "merge to main" {
			log.Info(header + "")
			continue
		}
		if repo.CheckDirty() {
			log.Info(header + "")
			continue
		}
		log.Info(header + "")
		check := me.forge.Repos.FindByGoPath(repo.GoPath())
		if check == nil {
			log.Info("boo, you didn't git clone", repo.GoPath())
			continue
		}
		me.forge.StandardReleaseHeader(check, repo.State())
	}
	log.Info(fmt.Sprintf("EVERYTHING WORKED repo count = %d", count))
}

func PrintReleaseReport(readonly string, perfect string) {
	var count int

	log.Info(repolist.ReleaseReportHeader())

	loop := me.forge.Repos.SortByGoPath()
	for loop.Scan() {
		check := loop.Next()
		if me.forge.IsReadOnly(check) {
			continue
		}
		if check.GetCurrentBranchVersion() == check.GetTargetVersion() {
			continue
		}
		count += 1
		if check == nil {
			log.Info("boo, you didn't git clone", check.GoPath)
			continue
		}
		log.Info(me.forge.StandardReleaseHeader(check, ""))
	}
	log.Info(fmt.Sprintf("total repo count = %d", count))
}
